#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <vector>
#include <cmath>
#include <cstdlib>
#include <cctype>
#include <sstream>
#include <ctime>


//timeHorizon: 42, 56 or 72
//Instance		A		B		C		D		E		F
//----------------------------------------------------------
//instance		1		2		3		4		5		6
//numShips		1		2		2		2		2		3
//numPorts		6		5		6		7		7		6
//numPickup		1		1		2		2		2		2
//numDelivery	3		2		2		3		3		2

///////////////////////////
////TYPE INSTANCE HERE/////
#define instance 1
#define timeHorizon 56
#define numShips 1
#define numPorts 6
#define numPickup 1
#define numDelivery 3
//////////////////////////
//////////////////////////

//FOR GRUNDIGERE FORKLARING AV KODEN, SE PATH.CPP OG PSEUDOKODE I "SUPPLY CHAIN OPTIMIZATION IN THE LNG BUSINESS"

using namespace std;

class Route{
public:
	int vesselName;
	double cost;
	int totalTime;
	vector<int> georoute;
	Route(int vesselNum){vesselName = vesselNum; cost = 0; totalTime = 1;}
	Route(){vesselName = 0; cost = 0; totalTime = 1; georoute.clear();}
};

class Loading{
public:
	int nTanks;
	int port;
	int ship;
	int time;
	int route;
	Loading(){nTanks = 0; port = 0; ship = 0; time = 0, route = 0;}
};

class Operation{
public:
	int port;
	int time;
	Operation(int theport, int thetime){port = theport; time = thetime;}
	Operation(){port = 0; time = 0;}
};

class OperationRoute{
public:
	vector<Operation> operations;
	int route;
	int duplicate;
	double cost;
	int ship;
	Operation endport;
	OperationRoute(){operations.empty(); route = 0; duplicate = 1; cost = 0.0; ship = 0;}
};


void createRoute(int port, int tempPort,const int &currentShip, Route inroute, vector<Route> & shipsroutes, const int TimeIJV[][numPorts][numPorts], const double CostIJV[][numPorts][numPorts]);

vector<OperationRoute> createAllOperations(vector<Route> &shipsroutes, const int TimeIJV[][numPorts][numPorts]);

void createPattern(vector<OperationRoute>::iterator it, Loading pd1, Loading pd2, Loading dd1, Loading dd2, int currentj, vector<OperationRoute> &alloperations, vector<Loading> pattern, vector<vector<Loading>> &allpatterns);

bool checkWaitingDays(Route inroute);

bool checkPickup(int port);

bool checkDelivery(int port);

int countDelivery(Route r);

bool checkDoubleDelivery(vector<Operation> operations, int j);

string printPort(int p);

Operation findEndPort(int ship, int TimeIJV[][numPorts][numPorts]);

double findOriginCost(int endport, int ship, double CostIJV[][numPorts][numPorts]);

string convertInt(int number)
{
   stringstream ss;
   ss << number;
   return ss.str();
}

string convertInstance(int inst)
{
	char instanceLetter = inst + 64;
	stringstream ss;
	ss << instanceLetter;
   
   return ss.str();
}

int main(){
	//START TIMER
	clock_t start = clock();
	double diff;
	//---------------

	//LESE FRA FIL
	ifstream fin;
	//fin.open("DataFile_" + convertInstance(instance)+ "_costwait.txt");
	fin.open("DataFile_" + convertInstance(instance)+ ".txt");
	if(fin.fail()){ cout << "Failed to open file"; exit(1);}
	
	string text; //midlertidig variabel som fjerner tekst fra filen
	fin >> text;
	
	//------------------------------
	//LESER INN PORTS FRA FIL
	vector <string> ports;
	string port;
	for(int i = 0; i < numPorts; i++){ 
		fin >> port; 
		ports.push_back(port);
	}
	//------------------------------

	cout << endl;
	fin >> text;
	//------------------------------
	//LESER INN TIDSMATRISE FRA FIL
	int TimeIJV[numShips][numPorts][numPorts];
		for(int i = 0; i < numShips; i++){
		for(int j = 0; j < numPorts; j++){
			for(int k = 0; k < numPorts; k++){
				fin >> TimeIJV[i][j][k];
			}
		}
	}
	//------------------------------

	fin >> text;
	//------------------------------
	//LESER INN KOSTNADSMATRISE FRA FIL
	double CostIJV[numShips][numPorts][numPorts];
	for(int i = 0; i < numShips; i++){
		for(int j = 0; j < numPorts; j++){
			for(int k = 0; k < numPorts; k++){
				fin >> CostIJV[i][j][k];
			}
		}
	}
	//------------------------------
	
	fin.close();

	//SKRIVER UT TIDS- OG KOSTNADSMATRISE
		for(int i = 0; i < numShips; i++){
		for(int j = 0; j < numPorts; j++){
			for(int k = 0; k < numPorts; k++){
				cout << TimeIJV[i][j][k] << " ";
			}
			cout << endl;
		}
		cout << endl;
	}
	cout << endl;
			for(int i = 0; i < numShips; i++){
		for(int j = 0; j < numPorts; j++){
			for(int k = 0; k < numPorts; k++){
				cout << CostIJV[i][j][k] << " ";
			}
			cout << endl;
		}
		cout << endl;
	}
	
	//CREATING DUTIES
	int tempPort = 1;
	Route newRoute;
	vector<Route> shipsroutes;
	for (int i = 1; i <= numShips; i++){
		tempPort = 1;
		newRoute.totalTime = 1;
		newRoute.vesselName = i;
		newRoute.georoute.clear();
		newRoute.georoute.push_back(tempPort);
		newRoute.georoute.push_back(numPorts);
		shipsroutes.push_back(newRoute);
		newRoute.georoute.pop_back();
		for(int j = 2; j < numPickup+2; j++){	
			if(TimeIJV[i-1][1-1][j-1] != -1){
				for (int k = 0; k < 3; k++){			
					newRoute.georoute.push_back(j);
					newRoute.totalTime += TimeIJV[i-1][tempPort-1][j-1];
					tempPort = j;
					shipsroutes.push_back(newRoute);
				}
			}
		}
	}
	//------------------------------------

	int currentPort = 2;
	tempPort = 2;
	int currentShip = 1;
	for (int vv = 0; vv < numShips; vv++){
		for (int i = 2; i < numPickup+2; i++){
		Route myRoute(currentShip);
		createRoute(i, tempPort, currentShip, myRoute, shipsroutes, TimeIJV, CostIJV);
		}
		currentShip++;
	}

	//WRITES TO FILE
	cout << "Writes to file!\n";
	ofstream outputFile;
	outputFile.open("Duties.txt");
	if (outputFile.fail()){
		cout << "Output file opening failed. \n";
		exit(1);
	}

	cout << "Current instance: " << convertInstance(instance) << endl;
	cout << "Planning horizon: " << convertInt(timeHorizon) << endl;
	outputFile << "Current instance: " << convertInstance(instance) << endl;
	outputFile << "Planning horizon: " << convertInt(timeHorizon) << endl;
	
	outputFile << "Duties: [ \n";
	for (unsigned int i = 0; i < shipsroutes.size(); i++){
			outputFile << "(";
			for (unsigned int j = 0; j <shipsroutes[i].georoute.size(); j++){
					outputFile << "'" << printPort(shipsroutes[i].georoute[j]) << "'" << "\t";
			}
		outputFile << ") " << shipsroutes[i].totalTime << "\n";
	}
	//--------------------------------------------

	//CREATING OPERATION ROWS
	outputFile << "]\n" << endl;
	outputFile << "Number of duties: " << shipsroutes.size() << endl;
	cout << "Duties written\n";
	outputFile.close();

	vector<OperationRoute> alloperations = createAllOperations(shipsroutes, TimeIJV);
	cout << "alloperations: " << alloperations.size() << endl;
	//---------------------------------

	//CREATING PATTERNS
	cout << "Creating patterns!\n";
	Loading p1, p2, d1, d2;
	int currentj = 0;
	vector<Loading> pattern;
	vector< vector<Loading> > allpatterns;
	vector<OperationRoute>::iterator it = alloperations.begin();
	while(it != alloperations.end()){
		createPattern(it, p1, p2, d1, d2, currentj, alloperations, pattern, allpatterns);
		it++;
	}
	cout << "Finished creating patterns.\n" ;
	cout << "allpatterns: " << allpatterns.size() << endl;
	diff = (clock() - start ) / (double)CLOCKS_PER_SEC;
	cout << "Time to generate all routes: " << diff << " seconds\n" << endl;
	//---------------------------------------

	//WRITES TO FILE
	//outputFile.open("DataFile_"+convertInstance(instance)+"_4_" + convertInt(timeHorizon) + "_"+convertInt(timeHorizon/2)+"_duty_costwait.txt");  //MED VENTEKOSTNAD
	//outputFile.open("DataFile_"+convertInstance(instance)+"_4_" + convertInt(timeHorizon) + "_"+convertInt(timeHorizon/2)+"_3days.txt");			//TRE TILLATTE VENTEDAGER P RAD
	//outputFile.open("DataFile_"+convertInstance(instance)+"_4_" + convertInt(timeHorizon) + "_"+convertInt(timeHorizon/3)+"_duty.txt");			//EKSTRA TIDSINTERVALL (3 I EN PLANNING PERIOD)
	outputFile.open("DataFile_"+convertInstance(instance)+"_4_" + convertInt(timeHorizon) + "_"+convertInt(timeHorizon/2)+"_duty.txt");
	
	if (outputFile.fail()){
		cout << "Output file opening failed. \n";
		exit(1);
	}

	outputFile << "!Time to generate all routes: " << diff << " seconds\n" << endl;
	int nRoutes = 0;
	int nDuplicates = 0;
	outputFile << "Nallroutes: " << allpatterns.size()+4*numShips << endl;
	outputFile << "PortOperations: [ \n";
	for (unsigned int i = 0; i < alloperations.size(); i++){
		for (unsigned int k = 0; k < alloperations[i].duplicate; k++){
			for (unsigned int j = 0; j < alloperations[i].operations.size(); j++){
					outputFile << "('S" << alloperations[i].ship << "', '" << printPort(alloperations[i].operations[j].port) << "', " << alloperations[i].operations[j].time << ", " << alloperations[i].route+nDuplicates+k << ") " << 1 << "\n";
			}
			nDuplicates += k;
		}
	}
	outputFile << "]\n" << endl;
	nDuplicates = 0;
	outputFile << "EndPortOperations: [ \n";
	for (unsigned int i = 0; i < alloperations.size(); i++){
		for (unsigned int k = 0; k < alloperations[i].duplicate; k++){
			if(alloperations[i].endport.port != -1){
					outputFile << "('S" << alloperations[i].ship << "', '" << printPort(alloperations[i].endport.port) << "', " << alloperations[i].endport.time << ", " << alloperations[i].route+nDuplicates+k << ") " << 1 << "\n";
			}
			nDuplicates += k;
		}
	}

	Operation endport;
	for (int i = 1; i <= numShips; i++){
		endport = findEndPort(i, TimeIJV);
		for (int j = 0; j < 3; j++){
			outputFile << "('S" << i << "', '" << printPort(endport.port) << "', " << endport.time+j << ", " << alloperations.size()+nDuplicates+j+1+((i-1)*3) << ") " << 1 << "\n";
		}
	}

	outputFile << "]\n" << endl;
	cout << "PortOperations written\n";
	
	nRoutes = 0;
	outputFile << "Loading: [ \n";
	for (unsigned int i = 0; i < allpatterns.size(); i++){
		nRoutes++;
		for (unsigned int j = 0; j < allpatterns[i].size(); j++){
			if(allpatterns[i][j].nTanks > 0){
				outputFile << "('S" << allpatterns[i][j].ship << "', '" << printPort(allpatterns[i][j].port) << "', " << allpatterns[i][j].time << ", " << nRoutes << ") " << allpatterns[i][j].nTanks << "\n";
			}
		}
	}
	outputFile << "]\n" << endl;
	cout << "Loading written\n";

	nRoutes = 0;
	outputFile << "Unloading: [ \n";
	for (unsigned int i = 0; i < allpatterns.size(); i++){
		nRoutes++;
		for (unsigned int j = 0; j < allpatterns[i].size(); j++){
			if(allpatterns[i][j].nTanks < 0){
				outputFile << "('S" << allpatterns[i][j].ship << "', '" << printPort(allpatterns[i][j].port) << "', " << allpatterns[i][j].time << ", " << nRoutes << ") " << -allpatterns[i][j].nTanks << "\n";
			}
		}
	}
	outputFile << "]\n" << endl;
	cout << "Unloading written\n";

	nDuplicates = 0;
	nRoutes = 0;
	outputFile << "COSTSailing: [ \n";
	for (unsigned int i = 0; i < alloperations.size(); i++){
		for (unsigned int k = 0; k < alloperations[i].duplicate; k++){
			nRoutes++;
			outputFile << "('S" << alloperations[i].ship << "', " << alloperations[i].route+nDuplicates+k << ") " << alloperations[i].cost << endl;
			nDuplicates += k;
		}
	}
	double originCost;
	for (int i = 1; i <= numShips; i++){
		originCost = findOriginCost(findEndPort(i, TimeIJV).port, i, CostIJV);
		for (int j = 0; j < 3; j++){
			outputFile << "('S" << i << "', " << alloperations.size()+nDuplicates+j+1+((i-1)*3) << ") " << originCost << endl;
		}
	}

	for (int i = 1; i <= numShips; i++){
		outputFile << "('S" << i << "', " << alloperations.size()+nDuplicates+i+numShips*3 << ") " << 0 << endl;
	}
	outputFile << "]\n" << endl;
	cout << "Costs written\n";
	outputFile.close();

	//STOP TIMER AND PRINT TIME	
	diff = (clock() - start ) / (double)CLOCKS_PER_SEC;
	cout << "Total time: " << diff << " seconds\n" << endl;
	system("pause");
	//-------------------------
	return 0;
}

void createRoute(int port, int tempPort, const int &currentShip, Route inroute, vector<Route> & shipsroutes, const int TimeIJV[][numPorts][numPorts], const double CostIJV[][numPorts][numPorts]){
		inroute.georoute.push_back(port);
		int deliveryInRow;
		if(inroute.georoute.size() > 1){
			inroute.totalTime += TimeIJV[currentShip-1][tempPort-1][port-1];
			inroute.cost += CostIJV[currentShip-1][tempPort-1][port-1];
			deliveryInRow = countDelivery(inroute);
		}
		bool checkWaiting = false;
		if(inroute.georoute.size() > 2){ //For two waiting days
		//if(inroute.georoute.size() > 3){ //For three waiting days
		checkWaiting = checkWaitingDays(inroute);
		}
		for (int jj = numPickup+2; jj < numPorts; jj++){
			if (TimeIJV[currentShip-1][port-1][jj-1] != -1){
						if((checkWaiting && (port != jj)) || !checkWaiting){
							if( (checkPickup(port) && checkDelivery(jj)) || port == 1 || port == jj || ((deliveryInRow==1 || deliveryInRow==2) && checkPickup(jj)) || (checkDelivery(port) && deliveryInRow < 2)){
								tempPort = port;
								createRoute(jj, tempPort, currentShip, inroute, shipsroutes, TimeIJV, CostIJV);
									
							}
						}
			}
		}

		if(inroute.georoute.size() > 1){
			inroute.georoute.push_back(numPorts);
			shipsroutes.push_back(inroute);
			inroute.georoute.pop_back();
			int last = port;
			for(int j = 2; j < numPickup+2; j++){
				port = last;
				if(TimeIJV[currentShip-1][last-1][j-1] != -1){
					for (int k = 0; k < 3; k++){			
						inroute.georoute.push_back(j);
						inroute.totalTime += TimeIJV[currentShip-1][port-1][j-1];
						inroute.cost += CostIJV[currentShip-1][port-1][j-1];
						port = j;
						shipsroutes.push_back(inroute);
					}
					port = last;
					for (int k = 0; k < 3; k++){	
						inroute.georoute.pop_back();
						inroute.totalTime -= TimeIJV[currentShip-1][port-1][j-1];
						inroute.cost -= CostIJV[currentShip-1][port-1][j-1];
						port = j;
					}

				}
			}
		}
}

		//Lage O-matrisen og Cost-matrisen
vector<OperationRoute> createAllOperations(vector<Route> &shipsroutes, const int TimeIJV[][numPorts][numPorts]){
	int tempTime = 1;
	int tempCost = 0;
	int tempRoute = 0;
	vector<OperationRoute> alloperations;
	OperationRoute newOperationRoute;
	Operation o;
	int n = shipsroutes.size()-1;
	int k = 0;
	while (!shipsroutes.empty()){
			newOperationRoute.ship = shipsroutes[n].vesselName;
			newOperationRoute.cost = shipsroutes[n].cost;
			for (int k = 0; k <= timeHorizon-shipsroutes[n].totalTime; k++){
				newOperationRoute.operations.clear();
				tempTime = 1;
					for (unsigned int j = 1; j < shipsroutes[n].georoute.size(); j++){
						if(shipsroutes[n].georoute[j-1] != shipsroutes[n].georoute[j] && shipsroutes[n].georoute[j-1]!= 1){ //Nr skipet forlater havn trigges O-parameteren
							o.port = shipsroutes[n].georoute[j-1]; 
							o.time = tempTime+k;
							newOperationRoute.operations.push_back(o);
							}
						tempTime += TimeIJV[shipsroutes[n].vesselName-1][(shipsroutes[n].georoute[j-1])-1][(shipsroutes[n].georoute[j])-1];
						if(j == shipsroutes[n].georoute.size()-1 && checkPickup(shipsroutes[n].georoute[j])){
							newOperationRoute.endport.port = shipsroutes[n].georoute[j];
							newOperationRoute.endport.time = tempTime+k;
						}
						else{
							newOperationRoute.endport.port = -1;
							newOperationRoute.endport.time = tempTime+k;
						}
					}
				if(!newOperationRoute.operations.empty()){
					tempRoute++;
					newOperationRoute.route = tempRoute;
					alloperations.push_back(newOperationRoute);
				}
			}
		shipsroutes.pop_back();
		n--;
	}
	return alloperations;
}

void createPattern(vector<OperationRoute>::iterator it, Loading pd1, Loading pd2, Loading dd1, Loading dd2, int currentj, vector<OperationRoute> &alloperations, vector<Loading> pattern, vector<vector<Loading>> &allpatterns){
	if (currentj > 0){
		pattern.push_back(pd1);
		pattern.push_back(pd2);
		pattern.push_back(dd1);
		pattern.push_back(dd2);
	}
	Loading p, d;
	while(currentj < it->operations.size()-1 && it->operations.size() >= 1){
		if(checkPickup(it->operations[currentj].port)){
			if(!checkDoubleDelivery(it->operations, currentj)){
				p.nTanks = 4;
				p.port = it->operations[currentj+1].port;
				p.ship = it->ship;
				p.time = it->operations[currentj].time;
				d.nTanks = -4;
				d.port = it->operations[currentj+1].port;
				d.ship = it->ship;
				d.time = it->operations[currentj+1].time;
				pattern.push_back(p);
				pattern.push_back(d);
			}
				else if (checkDoubleDelivery(it->operations, currentj)){
					it->duplicate ++;
					Loading pd1, pd2, dd1, dd2;
					for (int i = 2; i > 1 ; i--){ 
						pd1.nTanks = 1+i;
						pd1.port = it->operations[currentj+1].port;
						pd1.ship = it->ship;
						pd1.time = it->operations[currentj].time;
						pd2.nTanks = 3-i;
						pd2.port = it->operations[currentj+2].port;
						pd2.ship = it->ship;
						pd2.time = it->operations[currentj].time;
						dd1.nTanks = -(1+i);
						dd1.port = it->operations[currentj+1].port;
						dd1.ship = it->ship;
						dd1.time = it->operations[currentj+1].time;
						dd2.nTanks = -(3-i);
						dd2.port = it->operations[currentj+2].port;
						dd2.ship = it->ship;
						dd2.time = it->operations[currentj+2].time;
						createPattern (it, pd1, pd2, dd1, dd2, currentj+1, alloperations, pattern, allpatterns);
					}
						pd1.nTanks = 1;
						pd1.port = it->operations[currentj+1].port;
						pd1.ship = it->ship;
						pd1.time = it->operations[currentj].time;
						pd2.nTanks = 3;
						pd2.port = it->operations[currentj+2].port;
						pd2.ship = it->ship;
						pd2.time = it->operations[currentj].time;
						dd1.nTanks = -1;
						dd1.port = it->operations[currentj+1].port;
						dd1.ship = it->ship;
						dd1.time = it->operations[currentj+1].time;
						dd2.nTanks = -3;
						dd2.port = it->operations[currentj+2].port;
						dd2.ship = it->ship;
						dd2.time = it->operations[currentj+2].time;
						pattern.push_back(pd1);
						pattern.push_back(pd2);
						pattern.push_back(dd1);
						pattern.push_back(dd2);
				}
		//}
		}
		currentj++;
	}
	if(!pattern.empty()){
	allpatterns.push_back(pattern);
	}
}

//Max two waiting days
	bool checkWaitingDays(Route inroute){
	return (inroute.georoute[inroute.georoute.size()-1] == inroute.georoute[inroute.georoute.size()-2] && inroute.georoute[inroute.georoute.size()-1] == inroute.georoute[inroute.georoute.size()-3]);
}

//Max three waiting days
//	bool checkWaitingDays(Route inroute){
//	return (inroute.georoute[inroute.georoute.size()-1] == inroute.georoute[inroute.georoute.size()-2] && inroute.georoute[inroute.georoute.size()-1] == inroute.georoute[inroute.georoute.size()-3] && inroute.georoute[inroute.georoute.size()-1] == inroute.georoute[inroute.georoute.size()-4]);
//}

bool checkPickup(int port){
	return (port > 1 && port < numPickup+2);
}

bool checkDelivery(int port){
	return (port > 1+numPickup && port < numPorts);
}

int countDelivery(Route r){
	int count = 0;
	for (unsigned int i = 1; i < r.georoute.size(); i++){
		if(checkDelivery(r.georoute[i]) && (r.georoute[i] != r.georoute[i-1])){count++;}
		if(checkPickup(r.georoute[i])){count = 0;}
	}
	return count;
}

bool checkDoubleDelivery(vector<Operation> operations, int j){
	if ( j < operations.size()-2 ){
		if (checkDelivery(operations[j+1].port) && checkDelivery(operations[j+2].port)){return true;}
		else {return false;}
	}
	else {return false;}
}

string printPort(int p){
	stringstream ss;
	if (p > 1 && p <= 1+numPickup){
		ss << "P" << p-1;}
	if (p > numPickup+1 && p < numPorts){
		ss << "D" << p-numPickup-1;}
	if (p == 1){
		ss << "o";}
	if (p == numPorts){
		ss << "d";}
	return ss.str();
}

Operation findEndPort(int ship, int TimeIJV[][numPorts][numPorts]){
	Operation endport;
	for(int i = 1; i < numPorts; i++){
		if(TimeIJV[ship-1][0][i-1] != -1 && checkPickup(i)){
			endport.port = i;
			endport.time = TimeIJV[ship-1][0][i-1]+1;
		}
	}
	if(endport.port == 0){cout << "Invalid end port!\n";}
return endport;
}

double findOriginCost(int endport, int ship, double CostIJV[][numPorts][numPorts]){
return CostIJV[ship-1][0][endport-1];
}